Bug 4330 - Copyright statements out of date
Summary: Copyright statements out of date
Status: ASSIGNED
Alias: None
Product: Koha
Classification: Unclassified
Component: Architecture, internals, and plumbing (show other bugs)
Version: master
Hardware: All All
: P3 normal (vote)
Assignee: Chris Cormack
QA Contact: Marcel de Rooy
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: 2509
  Show dependency treegraph
 
Reported: 2010-03-22 10:01 UTC by Lars Wirzenius
Modified: 2016-09-29 16:43 UTC (History)
5 users (show)

See Also:
Change sponsored?: ---
Patch complexity: ---
Bot Control: ---
When did the bot last check this:
Who signed the patch off:
Text to go in the release notes:


Attachments
Proposed patch (640 bytes, patch)
2011-03-20 21:40 UTC, Chris Cormack
Details | Diff | Splinter Review
Another patch (657 bytes, patch)
2011-03-20 21:46 UTC, Chris Cormack
Details | Diff | Splinter Review
Bug 4330 : Updating copyright statements (837 bytes, patch)
2011-07-15 02:09 UTC, Chris Cormack
Details | Diff | Splinter Review
Bug 4330 : Updating copyright statements for about.pl (686 bytes, patch)
2011-07-15 02:10 UTC, Chris Cormack
Details | Diff | Splinter Review
Signed-off patches, squashed (1.15 KB, patch)
2011-08-16 12:19 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 4330: Wrong address for Free Software Foundation (2.53 KB, patch)
2011-11-21 07:31 UTC, Chris Cormack
Details | Diff | Splinter Review
Bug 4330: Missing License Statement (1.53 KB, patch)
2011-11-21 07:31 UTC, Chris Cormack
Details | Diff | Splinter Review
Signed patch: address FSF (2.63 KB, patch)
2011-11-21 07:47 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Signed patch: missing license (1.63 KB, patch)
2011-11-21 07:49 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Moving license scripts to misc (6.44 KB, patch)
2012-03-12 08:52 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Moving license scripts to misc (6.44 KB, patch)
2012-03-12 08:54 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Moving license scripts to misc (16.95 KB, patch)
2012-03-12 08:55 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Followup on find-license-problems.pl (954 bytes, patch)
2012-03-12 09:05 UTC, Marcel de Rooy
Details | Diff | Splinter Review
Bug 4330 : Fixing FSF address and copyright headers (3.24 KB, patch)
2012-05-20 09:56 UTC, Chris Cormack
Details | Diff | Splinter Review
Bug 4330 : Fixing FSF address and copyright statements (4.32 KB, patch)
2012-05-20 10:16 UTC, Chris Cormack
Details | Diff | Splinter Review
Bug 4330 Fixing FSF statements (13.59 KB, patch)
2012-05-20 10:28 UTC, Chris Cormack
Details | Diff | Splinter Review
Bug 4330 : Adding missing license statement (1.23 KB, patch)
2012-05-20 10:31 UTC, Chris Cormack
Details | Diff | Splinter Review
Bug 4330 : Last of the opac files with wrong FSF address (1.05 KB, patch)
2012-05-20 10:46 UTC, Chris Cormack
Details | Diff | Splinter Review
Bug 4330 : Fixing FSF address and copyright headers for acqui/ (3.21 KB, patch)
2012-05-21 07:35 UTC, Chris Cormack
Details | Diff | Splinter Review
Bug 4330 : Adding copyright headers and fixing FSF addresses (13.61 KB, patch)
2012-05-21 08:08 UTC, Chris Cormack
Details | Diff | Splinter Review
Bug 4330 : Fixing FSF address and copyright headers (3.34 KB, patch)
2012-05-26 11:12 UTC, Jared Camins-Esakov
Details | Diff | Splinter Review
Bug 4330 : Fixing FSF address and copyright statements (4.42 KB, patch)
2012-05-26 11:12 UTC, Jared Camins-Esakov
Details | Diff | Splinter Review
Bug 4330 Fixing FSF statements (13.70 KB, patch)
2012-05-26 11:12 UTC, Jared Camins-Esakov
Details | Diff | Splinter Review
Bug 4330 : Adding missing license statement (1.35 KB, patch)
2012-05-26 11:15 UTC, Jared Camins-Esakov
Details | Diff | Splinter Review
Bug 4330 : Last of the opac files with wrong FSF address (1.15 KB, patch)
2012-05-26 11:16 UTC, Jared Camins-Esakov
Details | Diff | Splinter Review
Bug 4330 : Fixing FSF address and copyright headers for acqui/ (3.31 KB, patch)
2012-05-26 11:16 UTC, Jared Camins-Esakov
Details | Diff | Splinter Review
Bug 4330 : Adding copyright headers and fixing FSF addresses (13.71 KB, patch)
2012-05-26 11:16 UTC, Jared Camins-Esakov
Details | Diff | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Chris Cormack 2010-05-21 01:25:54 UTC


---- Reported by lars@catalyst.net.nz 2010-03-22 22:01:25 ----

Many files in the Koha source tree have copyright statements that have years from, say, 2000-2002, but which have definitely been modified since. This makes it harder to keep track of who own the copyright for Koha.

It would be good to get the copyright statements updated, and to inflict procedures that keep them updated in the future.

The first part will require a lot of manual work, I am sure. For the second, it would be feasible to write a little helper script that aids the release manager by checking that a patch updates the Copyright statement, both owner and year.

(I had to pick a component, and there was no suitable one, so I picked one essentially by random. Sorry.)



---- Additional Comments From lars@catalyst.net.nz 2010-04-27 22:09:00 ----

A reasonable first step would be to write a script that data mines git for useful information, and makes a list that lists for each month the names and authors of each commit, and the files they have touched.

That list can then be manually processed to add information of who should be the copyright holder for each author for each month: the author themselves, or their employer or customer?

Then another script can take the adjusted list and check that each file has the right copyright statements.




--- Bug imported by chris@bigballofwax.co.nz 2010-05-21 01:25 UTC  ---

This bug was previously known as _bug_ 4330 at http://bugs.koha.org/cgi-bin/bugzilla3/show_bug.cgi?id=4330

Actual time not defined. Setting to 0.0
Setting qa contact to the default for this product.
   This bug either had no qa contact or an invalid one.

Comment 1 Lars Wirzenius 2010-06-10 03:13:15 UTC
Some further thoughts on this topic.

The goal:

* Every source file is clearly labelled with the correct copyright ownership
  and license information.
* "make test" or some other tool makes sure all files continue to have
  copyright and license information.
* The RM will reject patches in the future unless they make the necessary
  updates to each modified file.

Some thoughts:

* Getting this up to date and keeping it there is generally good, in case
  there are ever copyright disputes.
* Also good for getting Koha accepted as a package in Debian.
* Chris tells me all copyright info should be possible to pull from git.
  This will allow extraction of who edited. With only about 100 committers,
  some manual work to determine copyright owner for each committer should
  be completely feasible, even when some people (like Chris) have worked
  for different companies over the years.
  - write a little tool to data mine git for authors and the time spans
    they have worked in
* The exact same license statement should be used everywhere. Ideally, it
  would be exactly the same as in the GPL boilerplate.
* Debian ftpmaster advice on this topic:
  - http://lists.debian.org/debian-devel-announce/2003/12/msg00007.html
  - http://lists.debian.org/debian-devel-announce/2006/03/msg00023.html
Comment 2 Chris Cormack 2011-03-20 21:40:56 UTC Comment hidden (obsolete)
Comment 3 Chris Cormack 2011-03-20 21:41:53 UTC
Please leave this bug open, and we will just keep adding patches to fix the copyright statements
Comment 4 Chris Cormack 2011-03-20 21:46:34 UTC Comment hidden (obsolete)
Comment 5 Chris Cormack 2011-07-15 02:09:37 UTC Comment hidden (obsolete)
Comment 6 Chris Cormack 2011-07-15 02:10:36 UTC Comment hidden (obsolete)
Comment 7 Owen Leonard 2011-08-16 12:19:14 UTC Comment hidden (obsolete)
Comment 8 Ian Walls 2011-08-26 15:46:41 UTC
Comment-only change, adds information without removing any.  True to the best of my knowledge.  Marking as Passed QA
Comment 9 Chris Cormack 2011-08-26 19:57:16 UTC
Still many files to check, but pushed the patches
Comment 10 Chris Cormack 2011-11-21 07:31:49 UTC Comment hidden (obsolete)
Comment 11 Chris Cormack 2011-11-21 07:31:58 UTC Comment hidden (obsolete)
Comment 12 Marcel de Rooy 2011-11-21 07:47:21 UTC Comment hidden (obsolete)
Comment 13 Marcel de Rooy 2011-11-21 07:49:54 UTC Comment hidden (obsolete)
Comment 14 Marcel de Rooy 2011-11-21 07:51:38 UTC
QA: Only textual changes.
Comment 15 Paul Poulain 2011-11-24 13:17:32 UTC
patch pushed, please test

Push-notes: the 2nd patch was not applying on new/bug_4330 branch:

Applying: Bug 4330: Missing License Statement
Using index info to reconstruct a base tree...
Falling back to patching base and 3-way merge...
Auto-merging opac/sco/sco-main.pl
CONFLICT (content): Merge conflict in opac/sco/sco-main.pl
Failed to merge in the changes.
Patch failed at 0001 Bug 4330: Missing License Statement
When you have resolved this problem run "git am --resolved".
If you would prefer to skip this patch, instead run "git am --skip".
To restore the original branch and stop patching run "git am --abort".


As it's just some comment changes, i've pushed the two patches on master directly.

chris_n= can be applied on 3.6, but from pick-up the patch from master
Comment 16 Marcel de Rooy 2012-03-12 08:52:59 UTC Comment hidden (obsolete)
Comment 17 Marcel de Rooy 2012-03-12 08:54:11 UTC Comment hidden (obsolete)
Comment 18 Marcel de Rooy 2012-03-12 08:55:12 UTC Comment hidden (obsolete)
Comment 19 Chris Cormack 2012-03-12 08:55:39 UTC
Hmmm these scripts should stay in xt/

They are tests that should be run before release, by developers, not scripts that should be run by Koha users.
Comment 20 Marcel de Rooy 2012-03-12 09:05:44 UTC Comment hidden (obsolete)
Comment 21 Marcel de Rooy 2012-03-12 09:07:38 UTC
(In reply to comment #19)
> Hmmm these scripts should stay in xt/
> 
> They are tests that should be run before release, by developers, not scripts
> that should be run by Koha users.
xt is not completely clear to me? see also 7675
Comment 22 Marcel de Rooy 2012-03-12 09:11:23 UTC
xt/perltidyrc ?
Comment 23 Chris Cormack 2012-03-12 09:13:30 UTC
xt/ is tests, tests for things like template validity, missing copyrights.
Not unit tests, they live in t/

t/ tests functionality
xt/ tests things like translatablity, missing copyrights.

It should contain things meant to be run by the installer (like you selinux paths things in bug 7675) but should definitely contain scripts to check fsf addresses

xt/ is designed to contain best practice release only tests, so yes things like perltidy etc should live there. Things that don't effect functionality, but test style.
Comment 24 Marcel de Rooy 2012-03-12 09:16:51 UTC
OK Thanks. Obsoleting two attachments..
Comment 25 Chris Cormack 2012-05-20 09:56:31 UTC Comment hidden (obsolete)
Comment 26 Chris Cormack 2012-05-20 10:16:28 UTC Comment hidden (obsolete)
Comment 27 Chris Cormack 2012-05-20 10:28:21 UTC Comment hidden (obsolete)
Comment 28 Chris Cormack 2012-05-20 10:31:13 UTC Comment hidden (obsolete)
Comment 29 Chris Cormack 2012-05-20 10:46:21 UTC Comment hidden (obsolete)
Comment 30 Chris Cormack 2012-05-21 07:35:37 UTC Comment hidden (obsolete)
Comment 31 Chris Cormack 2012-05-21 08:08:20 UTC Comment hidden (obsolete)
Comment 32 Jared Camins-Esakov 2012-05-26 11:12:02 UTC Comment hidden (obsolete)
Comment 33 Jared Camins-Esakov 2012-05-26 11:12:18 UTC Comment hidden (obsolete)
Comment 34 Jared Camins-Esakov 2012-05-26 11:12:58 UTC Comment hidden (obsolete)
Comment 35 Jared Camins-Esakov 2012-05-26 11:15:51 UTC Comment hidden (obsolete)
Comment 36 Jared Camins-Esakov 2012-05-26 11:16:02 UTC Comment hidden (obsolete)
Comment 37 Jared Camins-Esakov 2012-05-26 11:16:13 UTC Comment hidden (obsolete)
Comment 38 Jared Camins-Esakov 2012-05-26 11:16:21 UTC Comment hidden (obsolete)
Comment 39 Paul Poulain 2012-05-28 15:53:30 UTC
QA comment: comment only changes, adding copyright and FSF address to files that lack them. passed QA, will push patches in master, mark them as obsolete and switch back to "assigned"
Comment 40 Paul Poulain 2012-05-28 15:55:05 UTC
Comment on attachment 9789 [details] [review]
Bug 4330 : Fixing FSF address and copyright headers

this patch has been pushed for 3.10
Comment 41 Paul Poulain 2012-05-28 15:55:11 UTC
Comment on attachment 9790 [details] [review]
Bug 4330 : Fixing FSF address and copyright statements

this patch has been pushed for 3.10
Comment 42 Paul Poulain 2012-05-28 15:55:18 UTC
Comment on attachment 9791 [details] [review]
Bug 4330 Fixing FSF statements

this patch has been pushed for 3.10
Comment 43 Paul Poulain 2012-05-28 15:55:29 UTC
Comment on attachment 9792 [details] [review]
Bug 4330 : Adding missing license statement

this patch has been pushed for 3.10
Comment 44 Paul Poulain 2012-05-28 15:55:34 UTC
Comment on attachment 9793 [details] [review]
Bug 4330 : Last of the opac files with wrong FSF address

this patch has been pushed for 3.10
Comment 45 Paul Poulain 2012-05-28 15:55:39 UTC
Comment on attachment 9794 [details] [review]
Bug 4330 : Fixing FSF address and copyright headers for acqui/

this patch has been pushed for 3.10
Comment 46 Paul Poulain 2012-05-28 15:55:45 UTC
Comment on attachment 9795 [details] [review]
Bug 4330 : Adding copyright headers and fixing FSF addresses

this patch has been pushed for 3.10